<?php
if (!defined('BASEPATH'))
	exit('No direct script access allowed');

class Main_model extends CI_Model {
	public function __construct() {
		parent::__construct();
	}

	public function getData($table,$fields='',$where='',$order_by='',$order_type='',$limit='',$start='')
	{
		if($fields!='' && $fields!='*')
			$this->db->select($fields);
		if($where!='')
		{
			if(is_array($where))
				$this->db->where($where);
			else
				$this->db->where($where, NULL, FALSE);
		}
		if($order_by!='')
			$this->db->order_by($order_by, $order_type);
		$query = $this->db->get($table);
		if($limit != '' && $start != '')
			$this->db->limit($limit, $start);
		$res = $query->result();
		if(count($res)>0)
			return $res;
		return FALSE;
	}
	
	public function getBackendData($table,$fields='',$where='',$order_by='',$order='',$limit='',$start='',$additional_params='')
	{
		if($fields!='' && $fields!='*')
			$this->db->select($fields, FALSE);
		if($where!='')
		{
			if(!is_array($where))
			{
				if(strpos($where, "(")!==0)
					$this->db->where($where, NULL, FALSE);
				else
					$this->db->where($where);
			}
			else
				$this->db->where($where);
		}
		if($order_by!='' && $order!='')
			$this->db->order_by($order_by, $order);
		if($limit !== '' && $start !== '')
			$this->db->limit($limit, $start);
		if($additional_params!='')
			foreach($additional_params as $k=>$v)
			{
				$k=str_replace("2", "", $k);
				$k=str_replace("3", "", $k);
				$k=str_replace("4", "", $k);
				if(count($v)==3)
					$this->db->$k($v[0],$v[1],$v[2]);
				elseif(count($v)==2)
					$this->db->$k($v[0],$v[1]);
				elseif(count($v)==1)
					$this->db->$k($v[0]);
			}
		
		$query = $this->db->get($table);
		$res = $query->result();
		if(count($res))
			return $res;
		return false;
	}

	public function count($table,$where='',$additional_params='')
	{
		if($where!='')
			$this->db->where($where);
		if($additional_params!='')
			foreach($additional_params as $k=>$v)
			{
				$k=str_replace("2", "", $k);
				$k=str_replace("3", "", $k);
				$k=str_replace("4", "", $k);
				if(count($v)==3)
					$this->db->$k($v[0],$v[1],$v[2]);
				elseif(count($v)==2)
					$this->db->$k($v[0],$v[1]);
				elseif(count($v)==1)
					$this->db->$k($v[0]);
			}
		return $this->db->count_all_results($table);
	}
	
	public function insert($table,$insertArr) {
		$this -> db -> insert($table, $insertArr);
		return $this -> db -> insert_id();
	}
	
	public function update($table,$updatedArr,$where) {
		$this->db->where($where);
		return $this->db->update($table, $updatedArr);
	}
	
	public function increment($table,$field,$where) {
		$this->db->query("update `".$table."` set `".$field."`=(`".$field."`+1) WHERE ".$where);
		return true;
	}
	
	public function decrement($table,$field,$where) {
		$this->db->query("update `".$table."` set `".$field."`=(`".$field."`-1) WHERE ".$where);
		return true;
	}
	
	public function delete($table,$where)
	{
		$this->db->delete($table,$where);
		return true;
	}
	
	public function getNotifications()
	{
		$pushNotificationPeriod=0;
		
		$send_minute=(intval(date('i'))-$pushNotificationPeriod);
		$this->db->where("(`last_sent` IS NULL or `last_sent`!='".date('Y-m-d')."') and Time(`notification_date`)='".date('H:i:00')."' and ((`notification_date`='".date('Y-m-d H:i:00')."' and `notification_type`='1') or `notification_type`='2' or (`".strtolower(date('l'))."`='1' and `notification_type`='3'))", NULL, FALSE);
		$query = $this->db->get('notification');
		$res = $query->result();
		if(count($res))
			return $res;
		return false;
	}
	
	function validate_login()
	{
		/*
		$this->db->where('username', $this->input->post('username'));
		$this->db->where('password', ($this->input->post('password')));
		$query = $this->db->get('admin');
		
		if($query->num_rows() == 1)
		{
			return true;
		} else {
			return false;
		}
		*/
		
		$this->db->where('username', $this->input->post('username'));
		$this->db->where('password', $this->input->post('password')/*md5($this->input->post('password'))*/);
		//$query = $this->db->get('admins');
		$query = $this->getData('admin','*');
			
		
		
		
		if($query)
		{
		$pass=$query[0]->password;
		if($pass ===$this->input->post('password'))
		return true;
		else
		return false;
		} else {
			return false;
		}
		
		
	}
	
	public function get_where_in($table,$field,$cond){
		$query = $this->db->select('user_id,name,email,phone,country_id,city_id,image,map_location,trusted,trust_percentage,followers_count');	
	
		//$query = $this->db->where('activated','1');
		
		$query = $this->db->where_in($field,$cond);
		$query = $this->db->get($table);
		$res = $query->result();
		if(count($res))
			return $res;
		return false;
		
		
		
	}
	
	public function trusted_user($newsArr,$liked){
		$query = $this->db->where_in('news_id',$newsArr);
		$query = $this->db->where('liked',$liked);
		$query = $this->db->get('news_likes');
		$res = $query->result();
		if(count($res))
			return count($res);
		return false;
		
		
		
	}
	
	public function getActiveUsers()
	{
		$userID=0;
				if(check_logedin()){
					$userID = $this->session->userdata('user_id');
				}
		$followers = $this->main_model->getData('user_followers','followerID',array('userID'=>$userID));
				//-$followers = array_unique($followers);
				//-				echo "<pre>";print_r($followers);die;
				
			//	$followeIDS[]=$userID;
				if($followers):
					foreach($followers as $follower)
					$followeIDS[] = $follower->followerID;
									$additional_params['where_not_in'] = array('user_id',$followeIDS);
					
				endif;
				
				
				
		$data=array();
		$additional_params['join'] = array('country','country.id=users.country_id','left');
		$additional_params['join2'] = array('cities','cities.id=users.city_id','left');
		$additional_params['order_by'] = array('news_count desc ,trust_percentage desc,  followers_count desc');
		$users = $this->getBackendData('users','users.user_id,users.name,users.email,
		users.phone,users.image,users.map_location,users.trusted,users.trust_percentage,
		users.country_id,users.city_id,country.name_ar as countryName_ar ,
		 country.name_en as countryName_en , cities.name_ar as cityName_ar,cities.name_en as cityName_en',
		 array('trusted'=>'1','map_location !='=>''),'','',10,0,$additional_params);
		if($users){
			foreach ($users as $key => $user) {
				$user->image = base_url().'third_party/uploads/profiles/'.$user->image;
				$data[]=$user;
			}
		}
		return $data;
		
	}	
	
		
}
?>