<?php
if (!defined('BASEPATH'))
	exit('No direct script access allowed');

require_once "main_model.php";
class Posts_model extends Main_model {

	public function __construct() {
		parent::__construct();
	}

	function GetCoursesOfCategory($category_ID) {

		//$today = date("Y-m-d");

		$this -> db -> select('C.*');

		$this -> db -> from('courses C');
		//$this -> db -> join('stores S', 'S.id=C.store_id');

		$this -> db -> where('C.enabled', 1);
		//$this -> db -> where('C.end_date >=', $today);
		//$this -> db -> where('S.enabled', 1);
		$this -> db -> where('C.category_id', $category_ID);

		$this -> db -> order_by("C.start_date", "ASC");

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetStoreSubscriptions($userID) {

		$today = date("Y-m-d");

		$this -> db -> select('SS.*,S.store_logo');

		$this -> db -> from('stores_subscriptions SS');
		$this -> db -> join('stores S', 'S.id=SS.store_id');

		$this -> db -> where('S.enabled', 1);

		$this -> db -> distinct();

		$this -> db -> where('SS.user_id', $userID);

		$this -> db -> order_by("SS.id", "ASC");

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetSavedCoupons($userID) {

		$today = date("Y-m-d");

		$this -> db -> select('C.*,S.store_logo');

		$this -> db -> from('coupons C');
		$this -> db -> join('stores S', 'S.id=C.store_id');
		$this -> db -> join('coupons_saved CS', 'CS.coupon_id=C.id');

		$this -> db -> where('C.enabled', 1);
		$this -> db -> where('C.end_date >=', $today);
		$this -> db -> where('S.enabled', 1);

		$this -> db -> distinct();

		$this -> db -> where('CS.user_id', $userID);

		$orderBY = "C.end_date";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetFavouriteStoresCoupons($userID) {

		$today = date("Y-m-d");

		$this -> db -> select('C.*,S.store_logo');

		$this -> db -> from('coupons C');
		$this -> db -> join('stores S', 'S.id=C.store_id');
		$this -> db -> join('stores_favorites SF', 'SF.store_id=S.id');

		$this -> db -> where('C.enabled', 1);
		$this -> db -> where('C.end_date >=', $today);
		$this -> db -> where('S.enabled', 1);

		$this -> db -> where('SF.user_id', $userID);

		$orderBY = "C.end_date";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetCouponsOfCategory($category_ID) {

		$today = date("Y-m-d");

		$this -> db -> select('C.*,S.store_logo');

		$this -> db -> from('coupons C');
		$this -> db -> join('stores S', 'S.id=C.store_id');

		$this -> db -> where('C.enabled', 1);
		$this -> db -> where('C.end_date >=', $today);
		$this -> db -> where('S.enabled', 1);
		$this -> db -> where('S.category_id', $category_ID);

		$orderBY = "C.end_date";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetSearchCoupons() {

		$today = date("Y-m-d");

		$this -> db -> select('C.*,S.store_logo');

		$this -> db -> from('coupons C');
		$this -> db -> join('stores S', 'S.id=C.store_id');

		/*$this -> db -> where('C.enabled', 1);
		 $this -> db -> where('C.end_date >=', $today);
		 $this -> db -> where('S.enabled', 1);*/
		$whreStr = "C.enabled =  1  AND  C.end_date >= '$today' AND  S.enabled = 1 ";

		if (isset($_GET['serchtxt']) && trim($_GET['serchtxt']) != "") {
			$srchTxt = trim($_GET['serchtxt']);

			$whreStr .= " AND ( C.description LIKE  '%$srchTxt%' OR  C.amount LIKE '%$srchTxt%' OR S.store_name LIKE '%$srchTxt%') ";
			/*$this -> db -> like('C.description', trim($_GET['serchtxt']), 'both');
			 $this -> db -> or_like('C.amount', trim($_GET['serchtxt']), 'both');
			 $this -> db -> or_like('S.store_name', trim($_GET['serchtxt']), 'both');*/
		}
		$this -> db -> where($whreStr);
		$orderBY = "C.end_date";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

		$this -> db -> select('ML.*');
		$this -> db -> from('monasbat_list ML');
		if (isset($_GET['serchtxt']) && trim($_GET['serchtxt']) != "") {
			$this -> db -> like('ML.title', trim($_GET['serchtxt']), 'both');
			$this -> db -> or_like('ML.description', trim($_GET['serchtxt']), 'both');
		}
		$this -> db -> where('ML.enabled', 1);
		$orderBY = "ML.sort_order";
		$orderType = "ASC";
		$this -> db -> order_by($orderBY, $orderType);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetMysubscription($userID = 0,$enabled = null) {
			
		$this -> db -> select('CS.*,Coursrs.course_name,Coursrs.live_class_link');

		$this -> db -> from('course_subscribers CS');
		$this -> db -> join('courses Coursrs', 'Coursrs.id=CS.course_id');

		$this -> db -> where('CS.user_id', $userID);
		if($enabled !=null){
				$this -> db -> where('CS.enabled', $enabled);
		}

		$orderBY = "CS.created";
		$orderType = "DESC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}



	}

	function GetBooksRequests($userID = 0) {

		$this -> db -> select('BR.*,SSN.name AS SherKaShnName');

		$this -> db -> from('books_requests BR');
		$this -> db -> join('sharekat_sha7n SSN', 'SSN.id=BR.sharekat_sha7n_id', 'left');

		$this -> db -> where('BR.user_id', $userID);

		$orderBY = "BR.created";
		$orderType = "DESC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetLatestCourses($limit = 0) {

		$today = date("Y-m-d");

		$this -> db -> select('C.*');

		$this -> db -> from('courses C');

		$this -> db -> where('C.enabled', 1);
		//$this -> db -> where('C.start_date >=', $today);

		if ($limit > 0) {
			$this -> db -> limit($limit, 0);
		}

		$this -> db -> order_by("id", "DESC");

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetFeaturedCourses($limit = 0) {

		$today = date("Y-m-d");

		$this -> db -> select('C.*');

		$this -> db -> from('courses C');

		$this -> db -> where('C.featured', 1);
		$this -> db -> where('C.enabled', 1);
		//$this -> db -> where('C.start_date >=', $today);

		if ($limit > 0) {
			$this -> db -> limit($limit, 0);
		}

		$this -> db -> order_by("start_date", "ASC");

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetLatestCoupons($limit = 0) {

		$today = date("Y-m-d");

		$this -> db -> select('C.*,S.store_logo');

		$this -> db -> from('coupons C');
		$this -> db -> join('stores S', 'S.id=C.store_id');

		//$this -> db -> where('C.featured', 1);
		$this -> db -> where('C.enabled', 1);
		$this -> db -> where('C.end_date >=', $today);
		$this -> db -> where('S.enabled', 1);

		if ($limit > 0) {
			$this -> db -> limit($limit, 0);
		}

		$orderBY = "C.id";
		$orderType = "DESC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetStoresOfCategory($category_ID = 0) {

		$this -> db -> select('S.*');

		$this -> db -> from('stores S');

		$this -> db -> where('S.enabled', 1);
		$this -> db -> where('S.category_id', $category_ID);

		$orderBY = "S.sort_order";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetPhoneNumbersByZones($zones = array(), $limit = 0) {
		$this -> db -> select('ZN.mobile_number');

		$this -> db -> from('zones_numbers ZN');

		$this -> db -> where_in('ZN.zone_id', $zones);
		$this -> db -> limit($limit, 0);

		$this -> db -> order_by("ZN.id", "DESC");

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();

		} else {
			return false;
		}

	}

	function GetPostsOfUser($userID = 0) {

		$this -> db -> select('M.*');

		$this -> db -> from('monasbat_list M');

		$this -> db -> where('M.owner_id', $userID);

		$orderBY = "M.date_time";
		$orderType = "DESC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetNotificationsOfUser($userID = 0) {
		$this -> db -> select('N.*');

		$this -> db -> from('notifications N');

		$this -> db -> where('N.user_id', $userID);
		$this -> db -> or_where('N.user_id', 0);

		$orderBY = "N.created";
		$orderType = "DESC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetRepliesOfMessage($msgID = 0) {

		$this -> db -> select('M.*,Sndrs.username AS sender_name,RSCrs.username AS reciver_name');

		$this -> db -> from('messages M');

		$this -> db -> where('M.parent_id', $msgID);
		//$this -> db -> or_where(array('M.receiver_id'=> $userID,'M.parent_id'=> 0));
		//$this -> db -> where(array('M._sender_id'=> $userID,'M.parent_id'=> 0));

		$this -> db -> join('users Sndrs', 'Sndrs.user_id=M.sender_id', 'left');
		$this -> db -> join('users RSCrs', 'RSCrs.user_id=M.receiver_id', 'left');

		$orderBY = "M.created";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetMessagesOfUser($userID = 0) {

		$this -> db -> select('M.*,Sndrs.username AS sender_name,RSCrs.username AS reciver_name,monsba.title AS monsba_name');

		$this -> db -> from('messages M');

		$whrStr = "(M.receiver_id = $userID OR M.sender_id = $userID) AND M.parent_id = 0 ";
		$this -> db -> where($whrStr, NULL, FALSE);
		//$this -> db -> where('M.sender_id', $userID);
		//$this -> db -> or_where(array('M.receiver_id'=> $userID,'M.parent_id'=> 0));
		//$this -> db -> where(array('M._sender_id'=> $userID,'M.parent_id'=> 0));

		$this -> db -> join('users Sndrs', 'Sndrs.user_id=M.sender_id', 'left');
		$this -> db -> join('users RSCrs', 'RSCrs.user_id=M.receiver_id', 'left');
		$this -> db -> join('monasbat_list monsba', 'monsba.id=M.monsba_id', 'left');

		$orderBY = "M.created";
		$orderType = "DESC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetFeaturedMonsbat($type = 0) {

		$limit =                          getSettingdata() -> num_of_monsbat_hp;

		$this -> db -> select('M.*');

		$this -> db -> from('monasbat_list M');

		$this -> db -> where('M.featured', 1);
		$this -> db -> where('M.enabled', 1);
		$this -> db -> limit($limit, 0);

		$orderBY = "M.sort_order";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetListMonsbat($type = 0) {

		$this -> db -> select('M.*');

		$this -> db -> from('monasbat_list M');

		$this -> db -> where('M.type_id', $type);
		$this -> db -> where('M.enabled', 1);

		$orderBY = "M.sort_order";
		$orderType = "ASC";

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetListFreelancers() {

		$this -> db -> select('usrs.*, CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('users usrs');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		if (isset($_GET['srch_txt']) && trim($_GET['srch_txt']) != "") {
			$this -> db -> like('full_name', trim($_GET['srch_txt']), 'both');
			$this -> db -> or_like('user_about', trim($_GET['srch_txt']), 'both');
		}

		$this -> db -> where('usrs.active', 1);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetMonsbaData($monbaID = 0) {
		$this -> db -> select('M.*');
		$this -> db -> from('monasbat_list M');
		$this -> db -> where('M.id', $monbaID);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> row();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetListPortfolios($user_id) {
		$this -> db -> select('PF.*, usrs.* ,CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('portfolios PF');
		$this -> db -> join('users usrs', 'usrs.user_id=PF.user_id');
		//$this -> db -> join('faq_answers FA', 'FA.faq_question_id=FQ.id', 'left');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		if ($user_id > 0) {
			$this -> db -> where('PF.user_id', $user_id);

		}

		/*******************search Filter**************/
		if (isset($_GET['srch_txt']) && trim($_GET['srch_txt']) != "") {
			$this -> db -> like('title', trim($_GET['srch_txt']), 'both');
			$this -> db -> or_like('description', trim($_GET['srch_txt']), 'both');
		}

		if (isset($_GET['added_date']) && trim($_GET['added_date']) != "") {

			$flterdate = trim($_GET['added_date']);

			switch ($flterdate) {

				case 'week' :
					$date_new = date('Y-m-d', strtotime('-7 days'));
					break;
				case 'month' :
					$date_new = date('Y-m-d', strtotime('-1 months'));
					break;

				case 'quarter' :
					$date_new = date('Y-m-d', strtotime('-3 months'));
					break;

				case 'half' :
					$date_new = date('Y-m-d', strtotime('-6 months'));
					break;

				case 'half' :
					$date_new = date('Y-m-d', strtotime('-1 year'));
					break;

				default :
					break;
			}

			$this -> db -> where('PF.created_date >=', $date_new);

		}

		if (isset($_GET['skills']) && count($_GET['skills']) > 0) {

			$flterdate = $_GET['skills'];

			$this -> db -> join('portfolios_skills PS', 'PS.portfolios_id=PF.id');
			$this -> db -> where_in('PS.skills_id', $flterdate);
			$this -> db -> group_by('PF.id');

		}

		/**********************************************/
		$orderBY = "start_date";
		$orderType = "DESC";
		if (isset($_GET['sort']) && trim($_GET['sort']) != "") {

			$sortkey = $_GET['sort'];
			switch ($sortkey) {

				case 'mst_view' :
					$orderBY = "view_count";
					break;
				case 'mst_fav' :
					$orderBY = "fav_count";
					break;

				case 'mst_like' :
					$orderBY = "likes_count";
					break;

				default :
					break;
			}

		}

		$this -> db -> order_by($orderBY, $orderType);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetAllQuestionData($question_id) {
		$this -> db -> select('FQ.*, usrs.*,COUNT(FA.id) AS CountAns, CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('faq_questions FQ');
		$this -> db -> join('users usrs', 'usrs.user_id=FQ.user_id');
		$this -> db -> join('faq_answers FA', 'FA.faq_question_id=FQ.id', 'left');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		$this -> db -> group_by('FA.faq_question_id');
		$this -> db -> where('FQ.id', $question_id);

		//$this -> db -> where('usrs.user_id', $user_id);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> row();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetAllForumQuestionData($question_id) {
		$this -> db -> select('FQ.*, usrs.*,COUNT(FA.id) AS CountAns, CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('forum_questions FQ');
		$this -> db -> join('users usrs', 'usrs.user_id=FQ.user_id');
		$this -> db -> join('forum_answers FA', 'FA.forum_question_id=FQ.id', 'left');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		$this -> db -> group_by('FA.forum_question_id');
		$this -> db -> where('FQ.id', $question_id);

		//$this -> db -> where('usrs.user_id', $user_id);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> row();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetAllFaqsQuestions($cat_id) {
		$this -> db -> select('FQ.*, usrs.full_name,usrs.user_image,COUNT(FA.id) AS CountAns');

		$this -> db -> from('faq_questions FQ');
		$this -> db -> join('users usrs', 'usrs.user_id=FQ.user_id');
		$this -> db -> join('faq_answers FA', 'FA.faq_question_id=FQ.id', 'left');

		$this -> db -> group_by('FA.faq_question_id');

		if (isset($_GET['srch_txt']) && trim($_GET['srch_txt']) != "") {
			$this -> db -> like('title', trim($_GET['srch_txt']), 'both');
			$this -> db -> or_like('FQ.content', trim($_GET['srch_txt']), 'both');
		}

		$orderBY = "created_date";
		$orderType = "DESC";
		if (isset($_GET['sort']) && trim($_GET['sort']) != "") {

			$sortkey = $_GET['sort'];
			switch ($sortkey) {
				case 'date' :
					$orderBY = "created_date";
					break;

				case 'view_count' :
					$orderBY = "view_count";
					break;
				case 'rplycnt' :
					$orderBY = "CountAns";
					$orderType = "DESC";
					break;

				case 'unans' :
					$orderBY = "answered";
					$orderType = "ASC";
					break;

				default :
					break;
			}

		}

		$this -> db -> order_by($orderBY, $orderType);

		if ($cat_id > 0) {
			$this -> db -> where('FQ.faq_cat_id', $cat_id);

		}
		//$this -> db -> where('usrs.user_id', $user_id);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetAllForumsQuestions($cat_id) {
		$this -> db -> select('FQ.*, usrs.full_name,usrs.user_image,COUNT(FA.id) AS CountAns');

		$this -> db -> from('forum_questions FQ');
		$this -> db -> join('users usrs', 'usrs.user_id=FQ.user_id');
		$this -> db -> join('forum_answers FA', 'FA.forum_question_id=FQ.id', 'left');

		if (isset($_GET['srch_txt']) && trim($_GET['srch_txt']) != "") {
			$this -> db -> like('title', trim($_GET['srch_txt']), 'both');
			$this -> db -> or_like('FQ.content', trim($_GET['srch_txt']), 'both');
		}

		$this -> db -> group_by('FA.forum_question_id');

		$orderBY = "created_date";
		$orderType = "DESC";
		if (isset($_GET['sort']) && trim($_GET['sort']) != "") {

			$sortkey = $_GET['sort'];
			switch ($sortkey) {
				case 'date' :
					$orderBY = "created_date";
					break;

				case 'view_count' :
					$orderBY = "view_count";
					break;
				case 'rplycnt' :
					$orderBY = "CountAns";
					$orderType = "DESC";
					break;

				case 'unans' :
					$orderBY = "answered";
					$orderType = "ASC";
					break;

				default :
					break;
			}

		}

		$this -> db -> order_by($orderBY, $orderType);

		if ($cat_id > 0) {
			$this -> db -> where('FQ.forum_cat_id', $cat_id);

		}
		//$this -> db -> where('usrs.user_id', $user_id);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetAllUserData($user_id) {
		$this -> db -> select('usrs.*, CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('users usrs');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		//$this -> db -> where('usrs.active', 1);
		$this -> db -> where('usrs.user_id', $user_id);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> row();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetPostsData($postid) {
		$this -> db -> select('MPosts.*, SubCat.name AS subcat_name,Maincats.name AS maincat_name,Maincats.id AS maincat_id, Maincats.details_page AS details_page,,usrs.*,CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('main_posts MPosts');
		$this -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');
		$this -> db -> join('main_categories Maincats', 'Maincats.id=SubCat.main_cat_id');
		$this -> db -> join('users usrs', 'usrs.user_id=MPosts.user_id');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		$this -> db -> where('MPosts.id', $postid);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData[0];

		} else {
			return false;
		}

	}

	function GetMainCategoryOfPost($postid) {

		$this -> db -> select('Maincats.*');

		$this -> db -> from('main_posts MPosts');
		$this -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');
		$this -> db -> join('main_categories Maincats', 'Maincats.id=SubCat.main_cat_id');
		$this -> db -> where('MPosts.id', $postid);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData[0];

		} else {
			return false;
		}

	}

	function GetPostsOfSubCat($subCatid) {

		$this -> db -> select('MPosts.*,usrs.*,CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('main_posts MPosts');
		$this -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');

		$this -> db -> join('users usrs', 'usrs.user_id=MPosts.user_id');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		/***************likes**************/
		/*$this -> db -> join('posts_likes PstLkes', 'PstLkes.post_id=MPosts.id AND PstLkes.status = 1', 'left');
		 //$this -> db -> where('PstLkes.status', 1);
		 $this -> db -> group_by('PstLkes.post_id');
		 //$this -> db -> group_by('PstUNLkes.post_id');
		 $this -> db -> join('posts_likes PstUNLkes', 'PstUNLkes.post_id=MPosts.id AND PstUNLkes.status = 0', 'left');
		 //$this -> db -> where('PstUNLkes.status', 0);*/

		/*****************Favourites***************/
		//$this -> db -> join('posts_favourites PstFavrts', 'PstFavrts.post_id=MPosts.id', 'left');
		//$this -> db -> group_by('PstLkes.post_id,PstFavrts.post_id');
		//$this -> db -> group_by('PstLkes.post_id');

		if (isset($_GET['srch_txt']) && trim($_GET['srch_txt']) != "") {
			$this -> db -> like('title', trim($_GET['srch_txt']), 'both');
			$this -> db -> or_like('description', trim($_GET['srch_txt']), 'both');
		}

		$this -> db -> where('SubCat.id', $subCatid);
		$this -> db -> where('MPosts.active', 1);

		/******************orderby ************************/
		$orderBY = "MPosts.id";
		$orderType = "DESC";
		if (isset($_GET['sort']) && trim($_GET['sort']) != "") {

			$sortkey = $_GET['sort'];
			switch ($sortkey) {
				case 'date' :
					$orderBY = "MPosts.created_date";
					break;

				case 'view_count' :
					$orderBY = "MPosts.view_count";
					break;
				case 'likes' :
					$orderBY = "MPosts.like_count";
					break;

				case 'price' :
					$orderBY = "MPosts.price";
					$orderType = "ASC";
					break;

				case 'favs' :
					$orderBY = "MPosts.favourite_count";
					break;

				case 'sales' :
					//-$orderBY = "FavCount";
					break;

				case 'guarant' :
					$orderBY = "guaranteed";
					break;

				case 'google_pr' :
					$orderBY = "MPosts.reviews_googlepr";
					break;

				case 'alexa' :
					$orderBY = "MPosts.reviews_alexa";
					break;

				case 'offer_start_date' :
					$orderBY = "MPosts.offer_start_date";
					$orderType = "ASC";

					break;

				case 'openads' :
					$orderBY = "MPosts.ads_end_date";
					$orderType = "DESC";
					break;
				case 'openOffer' :
					$orderBY = "MPosts.offer_end_date";
					$orderType = "DESC";
					break;

				default :
					$orderBY = "MPosts.$sortkey";
					break;
			}

		}

		$this -> db -> order_by($orderBY, $orderType);

		/***********************************************/

		//$this->db->order_by('F.ID','DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetListFooterUsers($lmit = 3) {

		$this -> db -> select('FU.*,usrs.*');

		$this -> db -> from('footer_users FU');

		$this -> db -> join('users usrs', 'usrs.user_id=FU.user_id');

		$this -> db -> where('usrs.active', 1);

		$this -> db -> limit($lmit, 0);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetListPostsGlobal($lmit = 4, $sort = "date") {

		$this -> db -> select('MPosts.*');

		$this -> db -> from('main_posts MPosts');

		$this -> db -> where('MPosts.active', 1);
		/******************orderby ************************/
		$orderBY = "MPosts.id";
		$orderType = "DESC";

		$sortkey = $sort;
		switch ($sortkey) {
			case 'date' :
				$orderBY = "MPosts.created_date";
				break;

			case 'likes' :
				$orderBY = "MPosts.like_count";
				break;

			default :
				$orderBY = "MPosts.$sort";

				break;
		}

		$this -> db -> order_by($orderBY, $orderType);
		$this -> db -> limit($lmit, 0);

		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetPostsOfUserWithMainCat($mainCatid, $user_id, $limit = 10) {

		$this -> db -> select('MPosts.*,usrs.*,SubCat.name AS subcatName');

		$this -> db -> from('main_posts MPosts');
		$this -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');
		$this -> db -> join('main_categories Maincats', 'Maincats.id=SubCat.main_cat_id');

		$this -> db -> join('users usrs', 'usrs.user_id=MPosts.user_id');

		$this -> db -> where('Maincats.id', $mainCatid);
		$this -> db -> where('MPosts.user_id', $user_id);
		$this -> db -> where('MPosts.active', 1);
		$this -> db -> order_by("MPosts.id", "DESC");
		$this -> db -> limit($limit, 0);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetPostsOfMainCat($mainCatid) {

		$this -> db -> select('MPosts.*,usrs.*,CUTR.country_name,CUTR.country_flag');

		$this -> db -> from('main_posts MPosts');
		$this -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');
		$this -> db -> join('main_categories Maincats', 'Maincats.id=SubCat.main_cat_id');

		$this -> db -> join('users usrs', 'usrs.user_id=MPosts.user_id');
		$this -> db -> join('countries CUTR', 'CUTR.id=usrs.country_id');

		/***************likes**************/
		/*$this -> db -> join('posts_likes PstLkes', 'PstLkes.post_id=MPosts.id AND PstLkes.status = 1', 'left');
		 //$this -> db -> where('PstLkes.status', 1);
		 $this -> db -> group_by('PstLkes.post_id');
		 //$this -> db -> group_by('PstUNLkes.post_id');
		 $this -> db -> join('posts_likes PstUNLkes', 'PstUNLkes.post_id=MPosts.id AND PstUNLkes.status = 0', 'left');
		 //$this -> db -> where('PstUNLkes.status', 0);*/

		/*****************Favourites***************/
		//$this -> db -> join('posts_favourites PstFavrts', 'PstFavrts.post_id=MPosts.id','left');
		//$this -> db -> group_by('PstLkes.post_id,PstFavrts.post_id');
		//$this -> db -> group_by('PstLkes.post_id');

		if (isset($_GET['srch_txt']) && trim($_GET['srch_txt']) != "") {
			$this -> db -> like('title', trim($_GET['srch_txt']), 'both');
			$this -> db -> or_like('description', trim($_GET['srch_txt']), 'both');
		}

		$this -> db -> where('Maincats.id', $mainCatid);
		$this -> db -> where('MPosts.active', 1);
		/******************orderby ************************/
		$orderBY = "MPosts.id";
		$orderType = "DESC";
		if (isset($_GET['sort']) && trim($_GET['sort']) != "") {

			$sortkey = trim($_GET['sort']);
			switch ($sortkey) {
				case 'date' :
					$orderBY = "MPosts.created_date";
					break;

				case 'view_count' :
					$orderBY = "MPosts.view_count";
					break;
				case 'likes' :
					$orderBY = "MPosts.like_count";
					break;

				case 'price' :
					$orderBY = "MPosts.price";
					$orderType = "ASC";
					break;

				case 'favs' :
					$orderBY = "MPosts.favourite_count";
					break;

				case 'sales' :
					//-$orderBY = "FavCount";
					break;

				case 'guarant' :
					$orderBY = "guaranteed";
					break;

				case 'google_pr' :
					$orderBY = "MPosts.reviews_googlepr";
					break;

				case 'alexa' :
					$orderBY = "MPosts.reviews_alexa";
					break;
				case 'offer_start_date' :
					$orderBY = "MPosts.offer_start_date";
					$orderType = "ASC";

					break;

				case 'openads' :
					$orderBY = "MPosts.ads_end_date";
					$orderType = "DESC";
					break;

				case 'openOffer' :
					$orderBY = "MPosts.offer_end_date";
					$orderType = "DESC";
					break;

				default :
					$orderBY = "MPosts.$sortkey";

					break;
			}

		}

		$this -> db -> order_by($orderBY, $orderType);

		/***********************************************/
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function save_new_credential($username, $password) {

		$teacher_Id = get_Front_teacher_logedin_id();

		$userNameExistBefore = $this -> isTeacherUserNameExist($username);

		if ($teacher_Id > 0 && $userNameExistBefore == false) {

			$this -> update("teacherlogin", array("UserName" => $username, "Password" => $password), array("TeacherID" => $teacher_Id));
			set_user_msg(1, "تم تحديث البيانات بنجاح ");

		} else {
			set_user_msg(2, "هذا المستخدم مسجل بالفعل الرجاء ادخال اسم مستخدم اخر   ");

		}

	}

	function isTeacherUserNameExist($username) {

		$teacher_Id = get_Front_teacher_logedin_id();

		$this -> db -> select('TeacherID');
		$this -> db -> where(array('UserName' => $username, "TeacherID != " => $teacher_Id));
		$query = $this -> db -> get('teacherlogin');

		$count = $query -> num_rows();
		if ($count > 0) {
			return true;
		}
		return false;
	}

	function getApproveFileId($File_ID) {
		$this -> db -> select('AF.ID AS ApproveID');

		$this -> db -> from('approvefile AF');
		$this -> db -> where('AF.fileID', $File_ID);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$rows = $query -> result_array();
			return $rows[0]['ApproveID'];

		} else {
			return false;
		}

	}

	function getVideoCommentsByTeachers($fileID) {
		$this -> db -> select('FC.*');

		$this -> db -> from('approvefile AF');
		$this -> db -> join('teachercomment TC', 'TC.AproveFileID=AF.ID');

		//$this -> db -> join('studentcomment SC', 'SC.ViewFileID=SVF.ID');

		$this -> db -> join('filecomment FC', 'FC.ID=TC.CommentID');
		//$this -> db -> join('studentregestration SR', 'SR.ID=SVF.StudentID');

		//$this -> db -> join('studentinfo SI', 'SI.ID=SR.StudentID');
		//$this -> db -> join('unite U', 'U.ID=L.UniteID');

		//$this -> db -> join('teacherinfo TINFO', 'TINFO.ID=TR.TeacherID');
		//$this -> db -> group_by('Q.ID');

		$this -> db -> where('AF.fileID', $fileID);
		//$this -> db -> where('F.FileType', 1);
		//$this->db->order_by('F.ID','DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();

		} else {
			return false;
		}

	}

	function InsertTeacherComment($FileCommentID, $approveFileId) {

		$this -> db -> insert('teachercomment', array("AproveFileID" => $approveFileId, "CommentID" => $FileCommentID));
		return $this -> db -> insert_id();

	}

	public function InsertFileComment($CommentText) {

		$this -> db -> insert('filecomment', array("Comment" => $CommentText, "CommentDate" => date("Y-m-d")));
		return $this -> db -> insert_id();
	}

	function getVideoComments($fileID) {

		$this -> db -> select('FC.*,SI.ID AS Student_id, SI.Name AS student_name, SI.StudentPhoto AS Student_Photo');
		//$this -> db -> select('AQH.Header AS question_header,Q.ID AS question_id, S.Subject AS subject_name');

		$this -> db -> from('approvefile AF');
		$this -> db -> join('studentviewfile SVF', 'SVF.FileID=AF.ID');

		$this -> db -> join('studentcomment SC', 'SC.ViewFileID=SVF.ID');

		$this -> db -> join('filecomment FC', 'FC.ID=SC.CommentID');
		$this -> db -> join('studentregestration SR', 'SR.ID=SVF.StudentID');

		$this -> db -> join('studentinfo SI', 'SI.ID=SR.StudentID');
		//$this -> db -> join('unite U', 'U.ID=L.UniteID');

		//$this -> db -> join('teacherinfo TINFO', 'TINFO.ID=TR.TeacherID');
		//$this -> db -> group_by('Q.ID');

		$this -> db -> where('AF.fileID', $fileID);
		//$this -> db -> where('F.FileType', 1);
		//$this->db->order_by('F.ID','DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();

		} else {
			return false;
		}

	}

	function getNonApprovedVideoDetails($fileID) {
		$this -> db -> select('F.*,NAF.Comment AS RejectReason ');
		$this -> db -> from('file F');
		$this -> db -> join('nonapprove NAF', 'NAF.FileID=F.ID');
		$this -> db -> where('F.ID', $fileID);
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$rows = $query -> result_array();
			return $rows[0];
		} else {
			return false;
		}

	}

	function getVideoDetails($fileID) {

		$this -> db -> select('F.*,L.LessonTitel AS Lesson_name, S.Subject AS Subject_name, U.UniteName AS Unit_name, TINFO.TeacherName AS Teacher_name,, COUNT(FEAT.FileID) as count_rate, SUM(FEAT.Rate) as sum_rate');
		//$this -> db -> select('AQH.Header AS question_header,Q.ID AS question_id, S.Subject AS subject_name');

		$this -> db -> from('teacherregestration TR');
		$this -> db -> join('suberteacherregester STR', 'STR.ID=TR.SuberTeacherRegestrationID');
		$this -> db -> join('subject S', 'S.ID=STR.SubjectID');

		$this -> db -> join('file F', 'F.TeacherRegesterID=TR.ID');
		$this -> db -> join('approvefile AF', 'AF.fileID=F.ID');
		$this -> db -> join('lesson L', 'L.ID=F.lessonID');
		$this -> db -> join('unite U', 'U.ID=L.UniteID');

		$this -> db -> join('teacherinfo TINFO', 'TINFO.ID=TR.TeacherID');

		$this -> db -> join('filereat FEAT', 'FEAT.FileID=AF.ID', 'left');
		$this -> db -> group_by('AF.ID');

		//$this -> db -> group_by('Q.ID');

		$this -> db -> where('F.ID', $fileID);
		//$this -> db -> where('F.FileType', 1);
		//$this->db->order_by('F.ID','DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$rows = $query -> result_array();
			return $rows[0];
		} else {
			return false;
		}

	}

	function getNotApprovedVideoList($teacher_Id) {

		$this -> db -> select('F.*,NAF.ID AS NApprove_ID,NAF.Comment AS RejectReason ,L.LessonTitel AS Lesson_name, S.Subject AS Subject_name, U.UniteName AS Unit_name');

		$this -> db -> from('teacherregestration TR');
		$this -> db -> join('suberteacherregester STR', 'STR.ID=TR.SuberTeacherRegestrationID');
		$this -> db -> join('subject S', 'S.ID=STR.SubjectID');

		$this -> db -> join('file F', 'F.TeacherRegesterID=TR.ID');
		$this -> db -> join('nonapprove NAF', 'NAF.FileID=F.ID');
		$this -> db -> join('lesson L', 'L.ID=F.lessonID');
		$this -> db -> join('unite U', 'U.ID=L.UniteID');

		$this -> db -> where('TR.TeacherID', $teacher_Id);
		$this -> db -> where('F.FileType', 1);
		$this -> db -> order_by('F.ID', 'DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();
		} else {
			return false;
		}

	}

	function getVideoListsOfTeacher($teacher_Id) {

		$this -> db -> select('F.*,AF.ID AS Approve_ID,L.LessonTitel AS Lesson_name, S.Subject AS Subject_name, U.UniteName AS Unit_name, COUNT(FEAT.FileID) as count_rate, SUM(FEAT.Rate) as sum_rate');
		//$this -> db -> select('AQH.Header AS question_header,Q.ID AS question_id, S.Subject AS subject_name');

		$this -> db -> from('teacherregestration TR');
		$this -> db -> join('suberteacherregester STR', 'STR.ID=TR.SuberTeacherRegestrationID');
		$this -> db -> join('subject S', 'S.ID=STR.SubjectID');

		$this -> db -> join('file F', 'F.TeacherRegesterID=TR.ID');
		$this -> db -> join('approvefile AF', 'AF.fileID=F.ID');
		$this -> db -> join('lesson L', 'L.ID=F.lessonID');
		$this -> db -> join('unite U', 'U.ID=L.UniteID');

		/*************to get comment count**************/
		//$this -> db -> join('studentviewfile SVF', 'SVF.FileID=AF.ID','left');

		//	$this -> db -> join('studentcomment SC', 'SC.ViewFileID=SVF.ID','left');

		//$this -> db -> join('filecomment FC', 'FC.ID=SC.CommentID',"left");

		/********************/

		$this -> db -> join('filereat FEAT', 'FEAT.FileID=AF.ID', 'left');
		$this -> db -> group_by('AF.ID');

		//$this -> db -> join('articalsubquestion ASQ', 'ASQ.HeaderID=Q.ID', 'left');
		//$this -> db -> group_by('Q.ID');

		$this -> db -> where('TR.TeacherID', $teacher_Id);
		$this -> db -> where('F.FileType', 1);
		$this -> db -> order_by('F.ID', 'DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();
		} else {
			return false;
		}

	}

	function getVideoCommentsCount($fileID) {

		$this -> db -> select('COUNT(FC.ID) AS Count_Comments');
		//$this -> db -> select('AQH.Header AS question_header,Q.ID AS question_id, S.Subject AS subject_name');

		$this -> db -> from('approvefile AF');
		$this -> db -> join('studentviewfile SVF', 'SVF.FileID=AF.ID');

		$this -> db -> join('studentcomment SC', 'SC.ViewFileID=SVF.ID');

		$this -> db -> join('filecomment FC', 'FC.ID=SC.CommentID');

		$this -> db -> where('AF.ID', $fileID);
		//$this -> db -> where('F.FileType', 1);
		//$this->db->order_by('F.ID','DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			$rows = $query -> result_array();
			return $rows[0]['Count_Comments'];

		} else {
			return false;
		}

	}

	function login($username, $password) {
		//$this -> db -> where("username", $username);
		$this -> db -> where("UserName", $username);
		$this -> db -> where("Password", $password);

		$query = $this -> db -> get("teacherlogin");
		if ($query -> num_rows() > 0) {
			foreach ($query->result() as $rows) {
				//add all data to session
				$newdata = array('teacher_front_uid' => $rows -> TeacherID, 'teacher_user_name' => $rows -> UserName, 'teacher_front_Login' => TRUE);
			}

			$this -> session -> set_userdata($newdata);
			set_user_msg(1, "تم تسجيل الدخول بنجاح ");
			return true;

		} else {
			set_user_msg(2, "معلومات الدخول غير صحيحة  ");
			return false;
		}

	}

	function getLessonsSearch($teacher_register_ID, $file_type) {

		$this -> db -> select('*');
		$this -> db -> from('file');
		$this -> db -> where(array("TeacherRegesterID" => $teacher_register_ID, "FileType" => $file_type));
		$this -> db -> order_by('ID', 'DESC');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();
		} else {
			return false;
		}

	}

	function getTeacherSubjects($teacher_Id) {

		$this -> db -> select('*,TR.ID AS TeacherRegesterID');
		$this -> db -> from('teacherregestration TR');
		$this -> db -> join('suberteacherregester STR', 'STR.ID=TR.SuberTeacherRegestrationID', 'left');
		$this -> db -> join('subject S', 'S.ID=STR.SubjectID', 'left');
		$this -> db -> join('level L', 'L.ID=S.LevelID', 'left');
		$this -> db -> where('TR.TeacherID', $teacher_Id);
		// $this->db->order_by('c.track_title','asc');
		$query = $this -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result_array();
		} else {
			return false;
		}

	}

	function update_user_password($email) {

		$password = rand(100000, 1000000);
		$data = array('password' => md5($password));
		$this -> db -> where('email', $email);
		$this -> db -> update('users', $data);

		return $password;

	}

	function isPasswordExist($password, $userId) {
		$this -> db -> select('user_id');
		$this -> db -> where(array('password' => $password, "user_id" => $userId));
		$query = $this -> db -> get('users');

		if ($query -> num_rows() > 0) {
			return true;
		} else {
			return false;
		}
	}

	function isEmailExist($email, $userId) {
		$this -> db -> select('user_id');
		$this -> db -> where(array('email' => $email, "user_id !=" => $userId));
		$query = $this -> db -> get('users');

		if ($query -> num_rows() > 0) {
			return true;
		} else {
			return false;
		}
	}

	public function update_password() {
		/*'username' => $this -> input -> post('username'), */
		$data = array('password' => $this -> input -> post('password'));
		$this -> db -> where('user_id', $this -> input -> post('user_id'));
		$this -> db -> update('users', $data);
	}

	public function verifiyUser($userIDD) {

		$userData["email_verified"] = 1;
		$this -> db -> where('user_id', $userIDD);
		$this -> db -> update('users', $userData);

	}

	public function update_user() {
		/*'username' => $this -> input -> post('username'), */

		$userData = $this -> input -> post();
		$userIDD = $this -> input -> post('user_id');
		unset($userData['user_id']);

		/*$data = array(
		 'display_name' => $this -> input -> post('display_name'),
		 'email' => $this -> input -> post('email'),
		 'phone' => $this -> input -> post('phone'),
		 'user_type' => $this -> input -> post('user_type')
		 );*/
		$this -> db -> where('user_id', $userIDD);
		$this -> db -> update('users', $userData);
	}

	public function getRandomWord($len = 15) {
		$word = array_merge(range('0', '9'), range('a', 'z'));
		shuffle($word);

		return substr(implode($word), 0, $len);
	}

	public function add_user() {

		$userData = $this -> input -> post();
		$userData['token'] = $this -> getRandomWord();
		unset($userData['password_confirm']);
		unset($userData['polices']);

		/*'username' => $this -> input -> post('username'), */
		/*$data = array(
		 'first_name' => $this -> input -> post('first_name'),
		 'email' => $this -> input -> post('email'),
		 'phone' => $this -> input -> post('phone'),
		 'user_type' => $this -> input -> post('user_type'),
		 'password' => md5($this -> input -> post('password')));*/
		$this -> db -> insert('users', $userData);
		return $userData['token'];
	}

}
?>